<?php
/**
*
* @package phpBB3
* @version $Id: functions_fchat.php 1.1.0 2009-10-07 09:51:19Z  $
* @copyright (c) 2010 topcmm.com
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*/
function fc_get_chat_url()
{
    global $settingscache, $grouptitlecache, $vbulletin, $vbphrase, $bgcounter, $settingphrase;
    $client = $vbulletin->options['fc_client'];
    $server = $vbulletin->options['fc_server'];
    $client_name = $client ? (($client == 1) ? 'htmlchat/123flashchat.html' : 'avatarchat.swf') : '123flashchat.swf';
    $chat_url = $vbulletin->options['fc_client_loc'] . $client_name . "?init_host=" . $vbulletin->options['fc_server_host'] . "&init_port=" . $vbulletin->options['fc_server_port'] . "&init_lang=" . $vbulletin->options['fc_client_lang'];
    if ($client == 0)
    {
        $chat_url .= "&init_skin=" . $vbulletin->options['fc_client_skin'];
    }
    if ($server == 1)
    {
        $chat_url .= "&init_group=" . $vbulletin->options['fc_group'];
    }
    return $chat_url;
}

function fc_get_status()
{   
    global $settingscache, $grouptitlecache, $vbulletin, $vbphrase, $bgcounter, $settingphrase;
    $status_json = $vbulletin->options['fc_status_json'];
    if ((time() > $vbulletin->options['fc_status_update_time']) || !$status_json)
    {
        $server =  $vbulletin->options['fc_server'];
        switch ($server)
        {   
            case 0:
        	    $status_js = $vbulletin->options['fc_api_url'] . "online.js";
        	    if($rs = @file_get_contents($status_js))
        	    {
        	        $status_json = substr($rs,11,-1);
        	    }
        	    break;
        	case 1:
        	    $status_js = $vbulletin->options['fc_api_url'] . "online.js?group=" . $vbulletin->options['fc_group'];
        	    if($rs = @file_get_contents($status_js))
        	    {
        	        $status_json = substr($rs,11,-1);
        	    }
        	    break;
        	case 2:
        	    $status_js = "http://free.123flashchat.com/freeroomnum.php?roomname=" . $vbulletin->options['fc_room'];
        	    if($rs = @file_get_contents($status_js))
        	    {
        	        $status['ln'] = substr($rs,22,-3);
        	        $status_json = json_encode($status);
        	    }
        	    break;
        }
        $status['fc_status_json'] = $status_json;
        $status['fc_status_update_time'] = time() + 150;
        save_settings($status);
    }
	return json_decode($status_json,true);
}


function fc_get_room_list()
{
    global $settingscache, $grouptitlecache, $vbulletin, $vbphrase, $bgcounter, $settingphrase;
	$rooms_json =  @file_get_contents("rooms.js");
    if ((time() > $vbulletin->options['fc_rooms_update_time']) || !$rooms_json)
    {
    	$server =  $vbulletin->options['fc_server'];
        switch ($server)
        {
            case 0:
        	    $room_js = $vbulletin->options['fc_api_url'] . "rooms.js";
        	    break;
            case 1:
        	    $room_js = $vbulletin->options['fc_api_url'] . "rooms.js?group=" . $vbulletin->options['fc_group'];
        	    break;
        }
        if($rs = @file_get_contents($room_js))
        {
        	$rooms_json = substr($rs,10,-1);
        }
        @file_put_contents("rooms.js",$rooms_json);
        $rooms['fc_rooms_update_time'] = time() + 150;
        save_settings($rooms);
    }

    return json_decode($rooms_json, true);
}


function fc_get_user_list()
{
    global $settingscache, $grouptitlecache, $vbulletin, $vbphrase, $bgcounter, $settingphrase;
	$users_json =  @file_get_contents("users.js");
    if ((time() > $vbulletin->options['fc_users_update_time']) || !$users_json)
    {
    	$server =  $vbulletin->options['fc_server'];
        switch ($server)
        {
            case 0:
                $rooms = fc_get_room_list();
                $users = array();
                foreach ($rooms as $room)
                {
                    $user_js = $vbulletin->options['fc_api_url'] . "roomonlineusers.js?roomid=" . $room['id'];
                    if($rs = @file_get_contents($user_js))
                    {
                        $users = array_merge($users, json_decode(substr($rs,20,-1),true));
                    }
                }
                $users_json = json_encode($users);
        	    break;
            case 1:
        	    $user_js = $vbulletin->options['fc_api_url'] . "roomonlineusers.js?group=" . $vbulletin->options['fc_group'];
        	    if($rs = @file_get_contents($user_js))
        	    {
        	        $users_json = substr($rs,20,-1);
        	    }
        	    break;
        	case 2:
        	    $user_js = "http://free.123flashchat.com/freeroomuser.php?roomname=" . $vbulletin->options['fc_room'];
        	    if($rs = @file_get_contents($user_js))
    	        {
    	            foreach (explode(',', substr($rs,22,-3)) as $user)
    	            {
    	                $users[] = array('name' => $user);
    	            }
    	        }
    	        $users_json = json_encode($users);
    	        break;
        }
        @file_put_contents("users.js",$users_json);
        $users['fc_users_update_time'] = time() + 150;
        save_settings($users);
    }

    return json_decode($users_json, true);
}
?>
